$! --- University of Sussex POPLOG file -----------------------------------
$! File:            $usepop/master/C.vms/com/myfiles.com
$! Purpose:         find all files that belong to user
$! Author:          Brian Williams, ???
$! Documentation:
$! Related Files:

$ ! This command procedure will do the job as quickly as a DIR into a file
$ ! and use a lot less disk space doing it. It will run very slowly, as will
$ ! any program that does a similar job, because it has to open every file
$ ! individually to find the requisite information. Analyze is no use for
$ ! this, because it only returns file - id's not directories.
$ ! Consequently, it is best run as a batch job, and infrequently.
$ ! (Better still, why not avoid creating files in other people's directories
$ ! directly in the first place??)
$ !
$ ! Brian Williams
$ ! PS the command procedure takes one parameter, a wild card file-spec;
$ ! each file in the spec has its file ownership compared with that of the
$ ! issuing process. If other UICs need comparison, you will need to mod it.
$ !
$ set noverify
$ set noon
$ if p1.eqs."" then p1="[*...]*.*.*"
$ fs:='f$parse(p1)
$ nf: nf:='f$search(fs)
$ if nf.eqs."" then exit
$ pmem=f$getjpi("","mem")
$ fmem=f$file(nf,"mbm")
$ pgrp=f$getjpi("","grp")
$ fgrp=f$file(nf,"grp")
$ if pmem.ne.fmem then goto nf
$ if pgrp.ne.fgrp then goto nf
$ write sys$output nf
$ goto nf
